!- TRIANGULAR μOS 1.30/C128 for Commodore 128
!- UOS


!- Set BASIC variables & launch hardware tests & set memory variables :: set poke808 to 110/105 for disable/enable Run/Stop key
0graphic0,1:clr:slow:print"{ct h}{cyan}{142}":poke808,105:poke53269,.:poke53280,.:poke53281,.:q$=chr$(34):v$="1.30/c128":pa=65532:gosub96:gosub8:iffre(x)<53200thenn$="not enough ram!":goto22
1gosub20:fm=128:gosub8:gosub9:dd=1:poke3069,fm:poke3060,dd:poke3061,.:poke3066,158:poke3065,31:poke3067,.:poke3068,230:poke3062,1:poke3063,10:poke3064,20:bs=peek(3000):ifbs<8andbs>11thenbs=8

!- Launch screen
2bi=.:print"{clear}";:gosub8:print"{down*2}{purple}{cm @*40}";:gosub54:printtab(13)"{cm asterisk}{reverse on}            {reverse off}{sh pound}":gosub55:printtab(15)"{cm asterisk}{reverse on}        {reverse off}{sh pound}":gosub55:printtab(17)"{cm asterisk}{reverse on}    {reverse off}{sh pound}":gosub55:printtab(19)"{cm asterisk}{sh pound}":gosub55
3print"{down}{blue}{space*2}{cm c}{reverse on}{cm d}{cm k}{reverse off}{cm b}{reverse on}{cm k}{reverse off}{cm d}{cm b}{reverse on}{cm k}{reverse off}{cm f}{cm k}{reverse on}{cm b}{reverse off}{cm v}{cm k*3} {reverse on}{cm b}{reverse off}{cm f}{reverse on}{cm d}{reverse off}{cm f}{space*3}{light green}{reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm v} {light blue}(c) 2023{return}{blue}{space*3}{cm k}{reverse on}{cm k}{reverse off}{cm b}{reverse on}{cm k*2}{cm f}{cm k}{reverse off}{cm c}{cm k*6} {reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm f} {orange}{cm k*2}{light green}{cm k*2}{reverse on}{cm i}{reverse off}{cm k}{return}{blue}{space*3}{cm v}{cm c*6} {cm v}{cm c}{cm v}{reverse on}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v*5} {reverse on}{orange}{cm i}{reverse off}{cm k}{reverse on}{light green}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v}{cyan} "V$
4gosub8:ifrn=.then74
5printtab(26)"{down*4}{reverse on}{yellow}f1{reverse off} {green}bios setup";:poke208,.:gosub11
6getk$:ifk$="{f1}"then25

!- Load GUI
7n$="gui":l$=" loading...":print"{purple}";:gosub92:goto93

!- Delay 300 for's
8forj=.to300:nextj:return

!- Beep sound
9poke54296,15:poke54277,0:poke54278,248:poke54276,17:poke54272,.:poke54273,37:forj=.to80:nextj:poke54273,.:forj=.to60:nextj:return

!- Beep sound x3
10gosub9:gosub9:gosub9:return

!- Delay 1000 for's
11fori=.to1000:nexti:return

!- Disk dirve tests (drive # evaluatian: 8+di)
12open1,8+di,2:close1:ifst<>.then16
13gosub19:ifer$=""then16
14open1,8+di,15:print#1,"m-r";chr$(51);chr$(255):get#1,d$:t1=asc(d$+chr$(.)):close1:vt$="":open5,8+di,5,"uos>cfg,s,r":input#5,vt$:close5:gosub19:poke3011+di,1:poke3015+di,t1:bi=1:ifv$=vt$then17
15return
16poke3011+di,.:poke3015+di,.:return
17bd=8+di:ifbs=bdthent=1
18return

!- Read disk error channel
19open1,8+di,15:input#1,en$,er$,tr$,sc$:close1:return

!- Commodore 128 type confirmation
20poke208,.:poke842,167:poke843,189:poke208,2:getk$:geta$:k$=k$+a$:ifk$="{cm m}{cm x}"andpeek(pa)=61andpeek(pa+1)=255then23
21n$="can't run this{cm m}{cm x}os version!"

!- Shut down with error message
22l$="shut down...":print"{red}";:gosub92:print"{home}{red}"n$:gosub8:gosub10:goto98

!- Set up initial memory variables & cursor test & screen mode detection
23poke3071,6:restore:fori=.to5:readj:poke3051+i,j:nexti:print"{clear}{down}{cm p}";:gosub8:ifpeek(((peek(2619))*256)+40)=111thenpoke3070,40:fori=1to8:keyi,chr$(i+132):nexti:return:data19,13,82,85,78,13
24print"{clear}":gosub8:n$="this graphic mode is not supported!":goto22

!- BIOS Setup menu
25print"{clear}{down}{purple} {cm asterisk}{reverse on}{space*2}{reverse off}{sh pound}{cyan} triangular bios "v$"{return}{space*2}{purple}{cm asterisk}{sh pound}{cyan}{space*2}(c) 2023{down*2}{return}{space*2}{light green}commodore {orange}128{cyan}{space*2}ram:"fm"{left}kb{down}{return}{space*3}#: device:{space*9}boot/work":cs$="none":ifcs=1thencs$="cbm datasette":
26db=dd:wb=wd:bb=bd:print"   {reverse on}{red}1{cyan}{reverse off}: ":gosub82:fori=.to3
27gosub62:print"  "8+i;"{left}:",:ifdi(i)=.thenprint"{left*7}none"
28ifdi(i)=1thenprint"{left*4}cbm "dt$(i)"{return}","{up}{right*13}{reverse on}{yellow}"(i*2)+1"{left*3}f{right*3}{green}"(i*2)+2"{left*3}f{reverse off}{cyan}"
29nexti:print"{down}   boot:     work:{return}{down*2}  {reverse on}{red}t{cyan}{reverse off}ime:{return}{down}  {reverse on}{red}r{cyan}{reverse off}eset clock{return}{down*2}  {reverse on}{red}e{cyan}{reverse off}xit {reverse on}{red}s{cyan}{reverse off}ave {reverse on}{red}b{cyan}{reverse off}asic":poke208,.
30gosub56:gosub61:getk$:ifk$=""then30
31ifk$="e"thenprint"{clear}":dd=db:wd=wb:bd=bb:goto2
32ifk$="r"thenti$="000000"
33ifk$="1"thengosub85:gosub82
34ifk$="{f1}"theni=.:gosub57
35ifk$="{f2}"theni=.:gosub59
36ifk$="{f3}"theni=1:gosub57
37ifk$="{f4}"theni=1:gosub59
38ifk$="{f5}"theni=2:gosub57
39ifk$="{f6}"theni=2:gosub59
40ifk$="{f7}"theni=3:gosub57
41ifk$="{f8}"theni=3:gosub59
42ifk$="t"thengosub48
43ifk$="s"then46
44ifk$="b"then95
45goto30

46open1,bd,15,"r0:uos=uos":close1:gosub81:ifer<>63thengosub9:gosub9:goto30
47gosub80:goto94

!- Time change
48gosub97:print"{white} {arrow left} {cyan}type new time":ks$="":kv$="":poke208,.:fori=.to5
49gosub56:gosub61:print"{down}{right*8}{light green}"kv$"{cyan}":getk$:ifk$=""then49
50as=asc(k$):ifas>47andas<58thenks$=ks$+k$:goto52
51goto49

!- Time change display
52kv$=kv$+k$:ifi=1ori=3thenkv$=kv$+":"
53nexti:gosub97::print"                 ":ti$=ks$:poke208,.:return

!- Draw horizontal line 1
54print"{sh asterisk*40}":return

!- Draw horizontal line 2
55print"{cm t*40}":return

!- Time update > setup
56t$=ti$:t1$=left$(t$,2):t2$=mid$(t$,3,2):t3$=right$(t$,2):print"{home}{down*17}{right*8}"t1$":"t2$":"t3$:return

!- Set Boot drive
57ifpeek(3011+i)=1thenbd=8+i:return
58return

!- Set Work drive
59ifpeek(3011+i)=1thenwd=8+i:return
60return

!- Boot & Work disk drive update > setup
61print"{home}{down*14}{right*8}{yellow}"bd"{left} ","{left*2}{green}"wd"{left} {cyan}":return

!- Disk drive database
62di(i)=peek(3011+i):dn(i)=peek(3015+i):dt$(i)="{left*4}unknown":ifdi(i)=.thenreturn
63ifdn(i)=16thendt$(i)="2040"
64ifdn(i)=76thendt$(i)="1541-ii"
65ifdn(i)=170thendt$(i)="1541"
66ifdn(i)=173thendt$(i)="1571"
67ifdn(i)=108thendt$(i)="1581"
68ifdn(i)=7thendt$(i)="2031"
69ifdn(i)=32thendt$(i)="3040"
70ifdn(i)=169thendt$(i)="4040"
71ifdn(i)=255thendt$(i)="1551"
72ifdn(i)=48thendt$(i)="{left*4}sd2iec"
73return

!- Check disk drives
74t=.:fordi=3to.step-1:gosub12:nextdi:ift=1thenbd=bs
75wd=bd:poke3000,bd:poke3001,wd:ifbi=.thenee$="   {reverse on}no disk drive!{reverse off}":goto88
76ifbd=.thenee$="   {reverse on}no system disk!{reverse off}":goto88

!- Load uos>cfg
77rn=1:open8,bd,8,"uos>cfg,s,r":close8:gosub81:poke3062,1:ifer$<>"ok"then88
78open8,bd,8,"uos>cfg,s,r":input#8,v1$,wd$,dd$,gc$,gr$,cg$,tc$,pp$:close8:gosub81:poke3068,val(gr$):poke3067,val(gc$):poke3065,val(cg$):wd=val(wd$):dd=val(dd$):poke3060,dd:ifpeek(963+wd)=.thenwd=bd
79poke3001,wd:poke3066,val(tc$):poke3061,val(pp$):goto5

!- Save uos>cfg
80open1,bd,15,"s0:uos>cfg":close1:open8,bd,8,"uos>cfg,w,s":print#8,v$:print#8,wd:print#8,dd:print#8,peek(3067):print#8,peek(3068):print#8,peek(3065)::print#8,peek(3066):print#8,peek(3061):close8:poke3060,dd:poke3000,bd:poke3001,wd:gosub81:return

!- Read disk error chanell
81open1,bd,15:input#1,en$,er$,tr$,sc$:close1:return

!- Update Datasette status graphic > setup
82ifdd=.thenprint"{home}{down*8}{right*6}none         ":return
83ifdd=1thenprint"{home}{down*8}{right*6}cbm datasette":return
84return

!- Datasette enable On/Off
85ifdd=.thendd=1:return
86ifdd=1thendd=.:return
87return

!- Disk drive error
88printtab(9)"{down*2}{red}"ee$"{return}{down}{yellow} {reverse on}f1{green}{reverse off} retry"tab(31)"{red}{reverse on}f8{green}{reverse off} basic";:poke208,.:gosub10
89getk$:ifk$="{f1}"thenrn=.:print"{up*3}{black}":fori=.to2:print"{space*38}":nexti:print"{delete*2}{up*5}":goto4
90ifk$="{f8}"then95
91goto89

!- Draw load
92print"{clear}{down*15}"tab(17)"{cm asterisk}{reverse on}    {reverse off}{sh pound}{return}"tab(18)"{cm asterisk}{reverse on}  {reverse off}{sh pound}{return}"tab(19)"{cm asterisk}{sh pound}{return}{down}{white}"tab(12)"{cm @*16}{return}{white}"tab(11)"{cm m}{reverse on}{blue}{cm m*9}{reverse off}       {white}{cm g}{return}{white}"tab(12)"{cm t*16}{return}{white}{down}"tab(9)"     "l$:return

!- Load sequence
93print"{home}{black}load "q$n$q$","bd:poke208,.:fori=.to5:g=peek(3051+i):poke842+i,g:nexti:poke208,6:new

!- Restaring
94l$="restarting...":print"{yellow}";:gosub92:n$="uos":goto93

!- Shut down
95l$="shut down...":print"{red}";:gosub92:goto98

!- Clear SID
96fori=54272to54296:pokei,.:nexti:return

!- Clear Time changer
97gosub61:print"{down}{right*8}       ";:return

!- Shut down perform reset
98gosub11:print"{clear}":sys57344
